/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Assay N80 Performance
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.00	1996/06/27	porting DOS version on WinG
 **		1.20	1997/08/10	porting WinG version on Win32/DirectX
 **		1.30	1998/03/12	
 **		1.43	2007/09/01	XPΉ
 **		1.44	2009/12/15	Vista/7Ή
 **		1.51	2010/01/27	DirectSound OnlyɕύX
 **------------------------------------------------------------------------*/
#ifndef  _N80_ASSAY_H_
#define  _N80_ASSAY_H_
#include <windows.h>
/**==========================================================================
 **		N80NX
 **========================================================================*/
class n80_assay
{
	//-----------------------------------------------------------------------
	//	oϐ
	//-----------------------------------------------------------------------
	private:
	HANDLE				m_mutex;
//#if defined(_TEST) || defined(_DEBUG)
	HANDLE				m_file;					// Log Filenh
	int					m_log_open_failed;		// Log File Opens

	LONGLONG			m_z80_hires_base_ticks;	// Z80xx^C}[
	double				m_z80_hires_rates;		// Z80x^C}[ݐ
	LONGLONG			m_z80_adjust_skips;		// Z80Wb^[ݐϐ
	LONGLONG			m_z80_loops;			// Z80x
	LONGLONG			m_z80_loops_waited;		// Z80xWait
	DWORD				m_z80_sleep_cnt;		// Z80xSleep

	LONGLONG			m_tick_delay;			// Beep 200ms(0.20sec) Tick
	LONGLONG			m_feed_total;			// xt
	LONGLONG			m_feed_rack;			// Tvs(Beep)
	LONGLONG			m_feed_over;			// Tv߉
	LONGLONG			m_feed_log_ticks;		// t_Ticks
	LONGLONG			m_feed_pys_ticks;		// tTicks
	LONGLONG			m_feed1_rack;			// Tvs(PCG #1)
	LONGLONG			m_feed1_over;			// Tv߉
	LONGLONG			m_feed1_log_ticks;		// t_Ticks
	LONGLONG			m_feed1_pys_ticks;		// tTicks
	LONGLONG			m_per_freq;				// x^C}[g
	LONGLONG			m_feed_percounter;		// O񉉑t̍xl
	double				m_feed_intervals;		// tԊuݐ
//#endif
	//-----------------------------------------------------------------------
	//	RXgN^^fXgN^
	//-----------------------------------------------------------------------
	public:
						n80_assay(void);
	virtual				~n80_assay(void);
	//-----------------------------------------------------------------------
	//	^j֐
	//-----------------------------------------------------------------------
	protected:
	virtual void		init();					// 
	virtual void		dispose();				// j
	//-----------------------------------------------------------------------
	//	Oo͊֐
	//-----------------------------------------------------------------------
	public:
	virtual void		outputLog(LPCTSTR fmt, ...);
	virtual void		outputLastError();
	//-----------------------------------------------------------------------
	//	Z80x֐
	//-----------------------------------------------------------------------
	virtual void		setZ80ticks(LONGLONG ticks);
	virtual void		measureZ80Clock(int loops, LONGLONG ticks);
	virtual void		countZ80Sleep();
	//-----------------------------------------------------------------------
	//	tԊu֐
	//-----------------------------------------------------------------------
	virtual void		beginTakeInterval();
	virtual void		changeTakeInterval(DWORD z80clk);
	virtual void		takeFeedIntervals();
	virtual void		takeFeedTicks(LONGLONG beepticks, LONGLONG pcgticks);
	//-----------------------------------------------------------------------
	//	茋ʏo͊֐
	//-----------------------------------------------------------------------
	virtual void		showResult();
};
#endif //_N80_ASSAY_H_
