/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Main Window
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.00	1996/06/27	porting DOS version on WinG
 **		1.20	1997/08/10	porting WinG version on Win32/DirectX
 **		1.30	1998/03/12	
 **		1.43	2007/09/01	XPΉ
 **		1.44	2009/12/15	Vista/7Ή
 **		1.51	2010/01/27	DirectSound OnlyɕύX
 **------------------------------------------------------------------------*/
#include "n80_form.h"
#include "n80_directx.h"
#include "../z80/z80_thread.h"
#include <stdio.h>
/**--------------------------------------------------------------------------
 **		O[oϐ
 **------------------------------------------------------------------------*/
extern n80_assay	*assay;
extern n80_directx	*dx;
extern z80_thread	*th;
/**--------------------------------------------------------------------------
 **		RXgN^^fXgN^
 **------------------------------------------------------------------------*/
n80_form::n80_form (HINSTANCE hInstance)
{
	mInstance = hInstance;
	mReqRestart = FALSE;	// Z80 thread ăX^[gv敪F Ȃ
	mLostDDS = FALSE;		// DirectDraw Surface敪F L
	m_key_combo = KEYCOMB_CLEAR;
	m_config_mode = FALSE;
	::InitializeCriticalSection(&m_csec);
}

n80_form::~n80_form ()
{
	assay->outputLog(TEXT("ENTER ~n80_form"));
	if (m_hevt_sync != NULL) {
		::CloseHandle(m_hevt_sync);
		m_hevt_sync = NULL;
	}
	if (m_hevt_ack != NULL) {
		::CloseHandle(m_hevt_ack);
		m_hevt_ack = NULL;
	}
	::DeleteCriticalSection(&m_csec);
	assay->outputLog(TEXT("LEAVE ~n80_form"));
}
/**--------------------------------------------------------------------------
 **		Window
 **------------------------------------------------------------------------*/
BOOL
n80_form::create (
	LPCSTR clsname, LPCTSTR title,
	int x,  int y, int width, int height)
{
	TCHAR             fileName[MAX_PATH+1];
	DWORD             size;
	BYTE*             pVersion;
	VS_FIXEDFILEINFO* pFileInfo;
	UINT              queryLen;
	 
	::GetModuleFileName(NULL, fileName, sizeof(fileName));
	 
	size = ::GetFileVersionInfoSize(fileName, NULL);
	pVersion = new BYTE[size];
	if (::GetFileVersionInfo(fileName, NULL, size, pVersion)) {
		::VerQueryValue(pVersion, TEXT("\\"), (void**)&pFileInfo, &queryLen);
		SHORT b = LOWORD(pFileInfo->dwFileVersionLS);
		if (b < 0) {
			sprintf(mTitleBase, TEXT("%s %d.%d.%d%d"), title,
				HIWORD(pFileInfo->dwFileVersionMS),
				LOWORD(pFileInfo->dwFileVersionMS),
				HIWORD(pFileInfo->dwFileVersionLS),
				b * -1);
		} else {
			sprintf(mTitleBase, TEXT("%s %d.%d.%d%c"), title,
				HIWORD(pFileInfo->dwFileVersionMS),
				LOWORD(pFileInfo->dwFileVersionMS),
				HIWORD(pFileInfo->dwFileVersionLS),
				b == 0 ? ' ' : 0x40 + b);
		}
	}
	delete[] pVersion;

	mWnd = ::CreateWindowEx (
		WS_EX_ACCEPTFILES,
		clsname,
		mTitleBase,
		//WS_POPUP | WS_VISIBLE,
		WS_POPUP | WS_SYSMENU | WS_CAPTION | WS_VISIBLE,
		x, y, width, height,
		NULL,
		(HMENU) 0,
		getInstance(),
		0);

	if (mWnd == NULL)
		return FALSE;
	else {
		::SetWindowLong (mWnd, GWL_USERDATA, (long) this);
		return TRUE;
	}
}
/**--------------------------------------------------------------------------
 **		WndProc
 **------------------------------------------------------------------------*/
LRESULT
n80_form::defWndproc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	if (m_config_mode && cfgWndproc(hwnd, msg, wp, lp) == 0)
		return 0;// ::DefDlgProc(hwnd, msg, wp, lp);

	switch (msg)
	{
	case  WM_ACTIVATEAPP:			// AvP[VtH[JX
		//assay->outputLog(TEXT("WM_ACTIVATEAPP"));
		OnAppActivate(wp);
		break;
	case  WM_Z80_START:				// Z80XbhJn
		start();
		break;
	case  WM_HALT_DETECT:			// Z80XbhُI
		assay->outputLog(TEXT("WM_HALT_DETECT"));
		halt((LPZ80CPU) wp);
		break;
	case WM_TITLE_UPDATE:
		title_update();
		break;
	case  WM_QUERYENDSESSION:		// Windows I𓾂悤ƂĂꍇB
		assay->outputLog(TEXT("WM_QUERYENDSESSION"));
		exit();						// N80I
		break;
	case WM_CLOSE:					// Window
		assay->outputLog(TEXT("WM_CLOSE"));
		exit();						// N80I
		::DestroyWindow(mWnd);
		break;
	case  WM_ERASEBKGND:
		if (OnEraseBkgnd((HDC) wp))
			return 1;
		break;
	case  WM_PAINT:
		OnPaint();
		break;
	case  WM_MOVE:
		dx->reaclcWindowRect();
		break;
	case WM_DROPFILES: {
		HDROP hdrop = (HDROP)wp;
		POINT pos;
		TCHAR path[512];
		::GetCursorPos(&pos);
		if (::ScreenToClient(mWnd, &pos)) {
			int num = ::DragQueryFile(hdrop, -1, NULL, 0);
			if (num > 0) {
				int unit = pos.x > 490 ? 1 : 0;
				::DragQueryFile(hdrop, 0, path, sizeof(path) / sizeof(TCHAR));
				this->drop_file(path, unit);
			}
		}
		::DragFinish(hdrop);
		break;
	}
	case WM_SYSKEYDOWN:
	case WM_KEYDOWN:
		if (!(lp & 0x40000000)) {	// Ỏ
			if (wp == VK_MENU) {
				m_key_combo = KEYCOMB_ALT;
				return 0;
			}
			else if (m_key_combo == KEYCOMB_ALT && wp == VK_DELETE) {
				m_key_combo = KEYCOMB_ALT_DEL;
				return 0;
			}
			else if (m_key_combo == KEYCOMB_ALT && wp == VK_INSERT) {
				m_key_combo = KEYCOMB_ALT_INS;
				return 0;
			}
			else if (m_key_combo == KEYCOMB_CLEAR)
				OnKeyDown(wp);
		}
		break;
	case WM_SYSKEYUP:
	case WM_KEYUP:
		if (wp == VK_MENU) {
			m_key_combo = KEYCOMB_CLEAR;
			return 0;
		}
		switch(wp) {
		case 0x31:		switch (m_key_combo) {
						case KEYCOMB_ALT_DEL:
							fd_eject(0);
							break;
						case KEYCOMB_ALT_INS:
							chooser(CHOOSER_MODE_D88, 0);
							break;
						default:
							OnKeyUp(wp);
							break;
						}
						break;
		case 0x32:		switch (m_key_combo) {
						case KEYCOMB_ALT_DEL:
							fd_eject(1);
							break;
						case KEYCOMB_ALT_INS:
							chooser(CHOOSER_MODE_D88, 1);
							break;
						default:
							OnKeyUp(wp);
						}
						break;
		case VK_F6:		if (::GetKeyState(VK_SHIFT) < 0)
							dx->toggleShowSysInfo();
						else
							dump();
						break;
		case VK_F7:		enter_config_mode()/*preference()*/;				break;
		case VK_F8:		dx->toggleMute();			break;
		case VK_F9:		if (::GetKeyState(VK_SHIFT) < 0)
							cmtsave();
						else
							chooser(CHOOSER_MODE_TAPE, -1);
						break;
		case VK_F10:	n80device.fdu.resume(&n80device.fdu);	break;
		case VK_F11:	n80device.pcg_mode ^= 0x01;
						n80device.attr.invalid();	break;
		case VK_F12:	if (::GetKeyState(VK_SHIFT) < 0)
							change_screen();
						else
							reset();
						break;
		case VK_SCROLL:
#if _DEBUG				// ޯޒF12 VisualStudio Ɗ̂[SCROLL/LOCK]őp
						if (::GetKeyState(VK_SHIFT) < 0)
							change_screen();
						else
							reset();
						break;
		case VK_PAUSE:	pause();
#endif
						break;
		case VK_END:	postMessage(WM_CLOSE, 0, 0);
						break;
		default:		OnKeyUp(wp);				break;
		}
		m_key_combo = KEYCOMB_CLEAR;
		break;
	case WM_SYSCOMMAND:
		if (LOWORD(wp) == IDM_N80CONFIG)
			preference();
		else if (LOWORD(wp) == IDM_N80HELP)
			about();
		else if (LOWORD(wp) == IDM_N80RESET)
			reset();
		else if (wp == SC_KEYMENU)
			return 0;
		else
			return ::DefWindowProc(hwnd, msg, wp, lp);
		break;
	case  WM_ENDSESSION:	// VXeI̓AvP[VI
	case  WM_DESTROY:		// jꂽꍇAAvP[VI
		assay->outputLog(TEXT("WM_DESTROY"));
		::SetWindowLong(mWnd, GWL_USERDATA, (long) NULL);
		::PostQuitMessage(0);
		break;
	default:
		return  ::DefWindowProc(hwnd, msg, wp, lp);
	}
	return 0;
}
/**--------------------------------------------------------------------------
 **		POST Message
 **------------------------------------------------------------------------*/
int
n80_form::postMessage(UINT msg, WPARAM wp, LPARAM lp)
{
	return ::PostMessage(mWnd, msg, wp, lp);
}
/**--------------------------------------------------------------------------
 **		Windos`揈
 **------------------------------------------------------------------------*/
void
n80_form::OnPaint()
{
	PAINTSTRUCT	ps;
	HDC			hdc;

	hdc = ::BeginPaint (mWnd, &ps);
	if (th->getZ80Paused())
		OnDraw (hdc);
	::EndPaint (mWnd, &ps);
}

void
n80_form::OnDraw(HDC hdc)
{
	POINT	size;
	RECT	rect;
	int		xc, yc;

	// N80 logo^CyCg
	if (::GetClientRect (mWnd, &rect)) {
		size.x = rect.right - rect.left;
		size.y = rect.bottom - rect.top;
		xc  = size.x / mLogo.getWidth ();
		xc += size.x % mLogo.getWidth () ? 1 : 0;
		yc  = size.y / mLogo.getHeight ();
		yc += size.y % mLogo.getHeight () ? 1 : 0;
		for (int row = 0; row < yc; row ++) {
			for (int col = 0; col < xc; col ++) {
				int x, y;
				x = col * mLogo.getWidth ();
				y = row * mLogo.getHeight ();
				::StretchDIBits (hdc, x, y,
					mLogo.getWidth (), mLogo.getHeight (),
					0, 0,
					mLogo.getWidth (), mLogo.getHeight (),
					(CONST VOID *) mLogo.getBytes (),
					(CONST BITMAPINFO *) mLogo.getBmpinfo (),
					DIB_RGB_COLORS, SRCCOPY);
			}
		}
	}
}

BOOL
n80_form::OnEraseBkgnd(HDC hdc)
{
	POINT	size;
	RECT	rect;
	HBRUSH	hbr = ::CreateSolidBrush((COLORREF) 0);

	if (::GetClientRect(mWnd, &rect)) {
		size.x = rect.right - rect.left;
		size.y = rect.bottom - rect.top;
		::SetRect(&rect, 0, 0, size.x, size.y);
		::FillRect(hdc, &rect, hbr);
		::DeleteObject(hbr);
		return  TRUE;
	}
	return FALSE;
	return TRUE;
}

void
n80_form::ForceShowCursor() {
	int cnt = ::ShowCursor(TRUE);
	if (cnt < 0) {
		for (int i = cnt; i < 0; ++i)
			::ShowCursor(TRUE);
	}
}

void
n80_form::ForceHideCursor() {
	int cnt = ::ShowCursor(FALSE);
	if (cnt > 0) {
		for (int i = cnt; i > 0; ++i)
			::ShowCursor(FALSE);
	}
}

void
n80_form::ShowCursorFullScreen() {
	if (dx->getFullScreenMode())
		ForceShowCursor();
}

void
n80_form::HideCursorFullScreen() {
	if (dx->getFullScreenMode())
		ForceHideCursor();
}

void
n80_form::title_update() {
	TCHAR title[512];
	BOOL gvram_wait_need = (n80device.io._i5C & _GVRAM_STS_GVRAM) && !(n80device.io._o40 & _PO40_FLASH) && (n80device.io._o31 & _PO31_GRAPH);
	BOOL tvram_wait_need = (n80device.crtc._text_visible & _TXTVIS_STOPALL) == 0;
	char g = gvram_wait_need ? 'G' : '-';
	char t = tvram_wait_need ? 'T' : '-';
	char f = n80device.io._o40 & _PO40_FLASH ? 'F' : '-';
	char subcpu = n80device.fdu.cpu_sleeping == 1 ? '-' : 'A';
	char d1 = n80device.fdu.fdd.drives[0].get_state(&n80device.fdu.fdd.drives[0]);
	char d2 = n80device.fdu.fdd.drives[1].get_state(&n80device.fdu.fdd.drives[1]);
	char p1 = n80device.fdu.ppi.state1;
	char p2 = n80device.fdu.ppi.state2;
	char phase = '-';
	for (int d = 0; d < 2; ++d) {
		switch (n80device.fdu.fdc.phase) {
		case FDC_PHASE_CMD:		phase = 'C';	break;
		case FDC_PHASE_EXE:		phase = 'E';	break;
		case FDC_PHASE_RESULT:	phase = 'R';	break;
		}
	}
	n80device.fdu.ppi.state1 = '-';
	n80device.fdu.ppi.state2 = '-';
	sprintf_s(title, sizeof(title), TEXT("%s   CLK/CPU=[%.3f/%.3f]  SUB[%c]  FDC[%c]  DRV[%c/%c]  PPI[%c/%c] V[%c/%c/%c]"),
		mTitleBase, n80win32.sys_hz, n80win32.eff_hz, subcpu, phase, d1, d2, p1, p2, g, f, t);
	::SetWindowText(mWnd, title);
}
#if _DEBUG
/**--------------------------------------------------------------------------
 **		Config
 **------------------------------------------------------------------------*/
extern "C" {
	extern BOOL _n88_debug_on;
}
void
n80_form::pause() {
	if (!m_pause_in && th->sync()) {
		m_pause_in = TRUE;
		n80device.logger("################################# Enter Pause #######################\n");
		dx->stop();
		ShowCursorFullScreen();
		::SetFocus(mWnd);
	}
	else if (m_pause_in) {
		n80device.logger("################################# Re-Pause #######################\n");
		_n88_debug_on = true;
		m_pause_in = FALSE;
		HideCursorFullScreen();
		::SetFocus(mWnd);
		n80device.attr.invalid();
		th->desync();
		dx->play();
	}
}
#endif
