/**--------------------------------------------------------------------------
 **
 **		NEC PC-8001 Emulator "N80" for Win32/DirectX
 **		--------------------------------------------
 **		Copyright (c) 1993-2010 H.Kanemoto
 **
 **		Dump N80 File
 **
 **		Rev		Date		Descriptions
 **		-----	----------	-----------------------------------------------
 **		1.00	1996/06/27	porting DOS version on WinG
 **		1.20	1997/08/10	porting WinG version on Win32/DirectX
 **		1.30	1998/03/12	
 **		1.43	2007/09/01	XPΉ
 **		1.44	2009/12/15	Vista/7Ή
 **		1.51	2010/01/27	DirectSound OnlyɕύX
 **------------------------------------------------------------------------*/
#include "n80_form.h"
#include "n80_directx.h"
#include "../pc-8001/pc-8001.h"
#include "../z80/z80_thread.h"
#include "../lib/icj_stream.h"
#include "../lib/icj_memory.h"
#include <stdio.h>
#include <string.h>
#include <crtdbg.h>
/**--------------------------------------------------------------------------
 **		O[oϐ
 **------------------------------------------------------------------------*/
extern z80_thread	*th;
extern n80_directx	*dx;
/**--------------------------------------------------------------------------
 **		_vt@Co
 **------------------------------------------------------------------------*/
void
n80_form::dump()
{
	char	path_name[512];

	if (th->sync())	{
		dx->stop();
		ShowCursorFullScreen();
		::InvalidateRect(mWnd, NULL, FALSE);

		if (save_file(path_name))
			write_file(path_name);

		HideCursorFullScreen();
		::SetFocus(mWnd);
		n80device.attr.invalid();
		th->desync();
		dx->play();
	}
}
/**--------------------------------------------------------------------------
 **		ۑt@C_CAO
 **------------------------------------------------------------------------*/
BOOL
n80_form::save_file(LPSTR szPath)
{
	OPENFILENAME	ofn;
	char	szName[16];
	char	szCurDir[512];
	char	szFilter[] = TEXT("N80 ۸̧\0*.N80\0\0");

	::ZeroMemory (&ofn, sizeof(OPENFILENAME));
	::GetCurrentDirectory (sizeof (szCurDir), szCurDir);
	szName[0] = 0x00;
	lstrcpy (szPath, TEXT("dump"));

	ofn.lStructSize			= sizeof (OPENFILENAME); 
	ofn.hwndOwner			= mWnd;
	ofn.hInstance			= NULL;
	ofn.lpstrFilter			= (const char *) szFilter;
	ofn.lpstrCustomFilter	= NULL; 
	ofn.nMaxCustFilter		= 0;
	ofn.nFilterIndex		= 0; 
	ofn.lpstrFile			= szPath;
	ofn.nMaxFile			= 512;
	ofn.lpstrFileTitle		= szName; 
	ofn.nMaxFileTitle		= sizeof (szName); 
	ofn.lpstrInitialDir		= szCurDir;
	ofn.lpstrTitle			= TEXT("N80 ̧ق̕ۑ"); 
	ofn.Flags				= OFN_OVERWRITEPROMPT | OFN_EXPLORER;
	ofn.nFileOffset			= 0; 
	ofn.nFileExtension		= 0; 
	ofn.lpstrDefExt			= TEXT("N80"); 
	ofn.lCustData			= 0; 
	ofn.lpfnHook			= NULL; 
	ofn.lpTemplateName		= NULL;

	return  ::GetSaveFileName (&ofn);
}
/**--------------------------------------------------------------------------
 **		ۑt@C_CAO
 **
 **		AR[hF
 **		----------			------------
 **		FF3D:	C9			RET
 **		FF3E:	50 FF		value of work SP
 **		FF40:	C1			POP	BC'
 **		FF41:	D1			POP	DE'
 **		FF42:	E1			POP	HL'
 **		FF43:	F1			POP	AF'
 **		FF44:	08			EX	AF,AF'
 **		FF45:	D9			EXX
 **		FF46:	C1			POP	BC
 **		FF47:	D1			POP	DE
 **		FF48:	E1			POP	HL
 **		FF49:	F1			POP	AF
 **		FF4A:	31 xx xx	LD	SP,xxxx
 **		FF4D:	C3 xx xx	JP	xxxx
 **		FF50:	40 FF		restore code start address
 **		FF52:	xx xx		value of BC'
 **		FF54:	xx xx		value of DE'
 **		FF56:	xx xx		value of HL'
 **		FF58:	xx xx		value of AF'
 **		FF5A:	xx xx		value of BC
 **		FF5C:	xx xx		value of DE
 **		FF5E:	xx xx		value of HL
 **		FF60:	xx xx		value of AF
 **
 **------------------------------------------------------------------------*/
static const BYTE	z80code[] = {
	0xc9,0x50,0xff,0xc1,0xd1,0xe1,0xf1,0x08,0xd9,
	0xc1,0xd1,0xe1,0xf1,0x31,0x00,0x00,0xc3,0x00,0x00,0x40,0xff
};
/**--------------------------------------------------------------------------
 **		DUMPt@Co
 **------------------------------------------------------------------------*/
void
n80_form::write_file(LPCSTR path_name)
{
	icj_fstream	fs;
	USHORT		regs[10];

	if (fs.create(path_name)) {
		fs.write(&n80device.mem._ram[0x8000], 32576, 1);
		fs.seek(FILE_BEGIN, 0x7f3d);
		fs.write((LPVOID) z80code, 21, 1);
		regs[0] = th->getRegister(Z80_SP);
		regs[1] = th->getRegister(Z80_PC);
		regs[2] = th->getRegister(Z80_BC2);
		regs[3] = th->getRegister(Z80_DE2);
		regs[4] = th->getRegister(Z80_HL2);
		regs[5] = th->getRegister(Z80_AF2);
		regs[6] = th->getRegister(Z80_BC);
		regs[7] = th->getRegister(Z80_DE);
		regs[8] = th->getRegister(Z80_HL);
		regs[9] = th->getRegister(Z80_AF);
		fs.seek(FILE_BEGIN, 0x7f4b);
		fs.write(&regs[0], 2, 1);
		fs.seek(FILE_BEGIN, 0x7f4e);
		fs.write(&regs[1], 2, 1);
		fs.seek(FILE_BEGIN, 0x7f52);
		fs.write(&regs[2], 18, 1);

		fs.close();
	}
}
