/**==========================================================================

	PC-8001 Device Emulator for Win32 Ver 1.10
	Copyright (C)1993-2010 H.Kanemoto

	This is a free software. You may copy or distribute
	it without any permissions. But there are NO WARRANTY
	of use. Entire risk of use is with you.

	External assembler functions for IBM-PC with VC++ 5.0
	last modified  Apr,4,1998.

;==========================================================================*/
#include <memory.h>
#include "PC-8001.h"
#ifdef _MSC_VER
#include <windows.h>
#endif
#ifdef __cplusplus
extern "C"
{
#endif
#define export
static BYTE	GRB2RGB[8] = //  GRB to RGB order
	{0x00,0x01,0x04,0x05,0x02,0x03,0x06,0x07};
 /**--------------------------------------------------------------------------
 **		ASM Modules
 **------------------------------------------------------------------------*/
static void _n80_attr_cache(int line) {
	int		i, s, r;
	LPBYTE	sort = &n80device.attr._attrcach[0];
	LPBYTE	src  = &n80device.mem._ram[n80device.dmac._begin + (120*line)];
	// VRAM 80Rs[
	for (i = 0; i < 80; ++i)
		n80device.attr._textcach[i] = *src++;

	// VRAM 40ŃRs[
	for (i = 0; i < 20; ++i) {
		sort[i*2]   = 0x50;
		sort[i*2+1] = 0;
	}
	for (i = 0, s = 0; i < 20; ++i) {
		BYTE colv = (*src++ & 0x7f);
		BYTE attr = *src++;
		sort[i*2+1] = attr;	//@\̓̕ђʂ
		//w蕔͏\[g
		if (i == 0) {
			sort[s*2] = colv;
			++s;
		} else if (colv == sort[(s-1)*2]) {
			;	//ꌅ̎w͖
		} else if (colv > sort[(s-1)*2]) {
			sort[s*2] = colv;
			++s;
		} else {
			int find = 0;
			//dw͖
			for (r = 0; r < s; ++r) {
				if (sort[r*2] == colv) {
					find = 1;
					break;
				}
			}
			if (!find) {
				//בւ
				for (r = s; r > 0; --r) {
					if (sort[(r-1)*2] > colv) {
						BYTE c = sort[(r-1)*2];
						sort[r*2] = c;
						sort[(r-1)*2] = colv;
					} else
						break;
				}
				++s;
			}
		}
	}
}
	
static __inline void _movcolor(void) {
	int i, j;
	BYTE pac, prev_color = n80device.attr._prevcolor;

	// F
	if (n80device.crtc._color_mode == 1) {
		// mN͔F
		memset(&n80device.attr._eval_attr[0], 7, 80);
	} else {
		int	start_col = -1;
		memset(&n80device.attr._eval_attr[0], 0, 80);
		for (i = 0; i < 20; ++i) {
			BYTE attr  = n80device.attr._attrcach[i*2+1];
			// Fw̏ꍇ
			if (attr & _ATTR_FNC_COLOR) {
				int cols = n80device.attr._attrcach[i*2];
				// FJnʒu̕ۑ
				if (start_col == -1)
					start_col = cols > 80 ? 80 : cols;
				
				if (cols < 80) {
					// GRB -> RGB
					pac = GRB2RGB[(attr >> 5) & 0x07];
					// ȈՃOtBbN
					if (attr & _ATTR_COLOR_GRAPH)
						pac |= _PAC_ATTR_GRAPH;
					// sJzF
					n80device.attr._prevcolor = pac;
					// v[z񏑂
					for (j = cols; j < 80; ++j)
						n80device.attr._eval_attr[j] = pac;
				}
			}
		}
		// rJnĂꍇ͍ŏIFŖ߂
		if (start_col > 0) {
			for (i = 0; i < start_col; ++i) {
				n80device.attr._eval_attr[i] = prev_color;
			}
		}
	}
}

static __inline void _movattr(void) {
	int i, j;
	BYTE prev_func = n80device.attr._prevfunc;
	BYTE mask = n80device.crtc._color_mode == 0 ? 0x17 : 0x07;
	
	int	start_col = -1;
	for (i = 0; i < 20; ++i) {
		BYTE attr = n80device.attr._attrcach[i*2+1];
		// @\w̏ꍇ
		if (n80device.crtc._color_mode == 1 || !(attr & _ATTR_FNC_COLOR)) {
			int cols = n80device.attr._attrcach[i*2];
			// @\Jnʒu̕ۑ
			if (start_col == -1)
				start_col = cols > 80 ? 80 : cols;
			
			if (cols < 80) {
				// PD3301 -> PAC
				BYTE pac = n80device.attr._convfunc(attr);
				//_łw肳Ăꍇ́AuNɏ
				//AAw肳Ăꍇ́AD悷
				if ((attr & 0x03) == _ATTR_FNC_BLINK && n80device.cursor._attr_blinking == 0) {
					pac |= _PAC_ATTR_ERASE;
				}
				for (j = cols; j < 80; ++j) {
					n80device.attr._eval_attr[j] &= mask;
					n80device.attr._eval_attr[j] |= pac;
				}
				// sJz@\
				n80device.attr._prevfunc = pac;// & 0x70;
			}
		}
	}
	// rJnĂꍇ͍ŏIFŖ߂
	if (start_col > 0) {
		for (i = 0; i < start_col; ++i) {
			n80device.attr._eval_attr[i] &= mask;
			n80device.attr._eval_attr[i] |= prev_func;
		}
	}
	// ][h̏ꍇ
	if (n80device.crtc._attr_reverse) {
		for (i = 0; i < 80; ++i)
			n80device.attr._eval_attr[i] ^= _PAC_ATTR_REVERSE;
	}
}
//-----------------------------------------------------------------------------
//	Plane Attribute Code (PAC) Format;	*ERG*RGB
//                                      ||||+
//                                      |||+ ȈՃOtBbN
//                                      ||+- ][h
//                                      |+-- [h
//                                      +--- [h
//-----------------------------------------------------------------------------
static __inline BYTE _chk_funcbit(BYTE al, BYTE cl) {
	if (al & _ATTR_FNC_ERASE)	// 
		cl |= _PAC_ATTR_ERASE;
	if (al & _ATTR_FNC_REVERSE)	// ]
		cl |= _PAC_ATTR_REVERSE;
	if (al & _ATTR_MONO_GRAPH)	// OtBbN
		cl |= _PAC_ATTR_GRAPH;
	if (al & _ATTR_OVER_LINE)	// 
		cl |= _PAC_ATTR_UPR_LINE;
	if (al & _ATTR_UNDER_LINE)	// 
		cl |= _PAC_ATTR_UND_LINE;
	return cl;
}

static BYTE _convmono(BYTE attr) {
	return _chk_funcbit(attr & 0xf7, 0);
}

static BYTE _convcolor(BYTE attr) {
	return _chk_funcbit(attr & 0x37, 0);
}

static int _n80_eval_attrib(int line) {
	int next = line == 24 ? 0 : line + 1, result = 0;

	if (line < 0 || line > 24)
		return 0;

	n80device.attr._prevcolor = n80device.attr._nextcolor[line];
	n80device.attr._prevfunc  = n80device.attr._nextfunc[line];
	
	// ]
	_movcolor();
	_movattr();

	// J[\ł̍XV
	if (n80device.cursor._row == line	&&
		n80device.cursor._blinking		&&
		n80device.cursor._enabled		&&
		(n80device.io._i5C & _GVRAM_STS_GVRAM) == 0) {
		n80device.attr._eval_attr[n80device.cursor._col] ^= 0x20;	// reverse
		n80device.attr._eval_attr[n80device.cursor._col] |= 0x07;	// color white
	}

	// sւ̌JzFύXɂȂꍇ
	if (n80device.attr._nextcolor[next] != n80device.attr._prevcolor)
		result = 1;
	n80device.attr._nextcolor[next] = n80device.attr._prevcolor;
	n80device.attr._nextfunc[next]  = n80device.attr._prevfunc;

	return result;
}

static void _n80_chg_converter(int mode) {
	n80device.attr._convfunc = mode == 0 ? _convcolor : _convmono;
}

static void _n80_attr_invalid(void) {
	int i;
	n80device.vram_sync_enter();
	for (i = 0; i < 25; ++i)
		n80device.attr._attrchg[i] = 1;
	n80device.vram_sync_leave();
}

static void _n80_attr_set(int line, BYTE flg) {
	if (line < 0 || line > 24)
		return;
	n80device.vram_sync_enter();
	n80device.attr._attrchg[line] = flg;
	n80device.vram_sync_leave();
}

static void _n80_reset_attr(void) {
	//attribute convert mode init (mono)
	_n80_chg_converter(1);
}

export void _n80_init_attr(void) {
	n80device.attr.grb_rgb = GRB2RGB;
	n80device.attr.reset = _n80_reset_attr;
	n80device.attr.chg_converter = _n80_chg_converter;
	n80device.attr.invalid = _n80_attr_invalid;
	n80device.attr.set = _n80_attr_set;
	n80device.attr.cache = _n80_attr_cache;
	n80device.attr.eval = _n80_eval_attrib;
	_n80_reset_attr();
}
	
#ifdef __cplusplus
}	// extern "C"
#endif
