//
//  PD8251.c
//  N88X
//
//  Created by hiroshi on 2016/05/02.
//  Copyright © 2016年 H.Kanemoto. All rights reserved.
//
#include "pc-8001.h"
#ifdef _MSC_VER
#include <windows.h>
#endif
#include <stdio.h>
#ifdef __cplusplus
extern "C"
{
#endif
#define export
#define _bIR	(0x40)
#define _bRxE	(0x04)
#define _bER	(0x10)
/**--------------------------------------------------------------------------
 **		ASM Modules
 **------------------------------------------------------------------------*/
static void _n80_sio_reset2(void) {
	n80device.usart._ir = 1;
	n80device.usart._rxe = 0;
	n80device.usart._rxd = 0;
	n80device.usart._rxrdy = 0;
	n80device.usart._ovr = 0;
}

static void _n80_sio_reset(void) {
	//n80device.usart._fake = 1;
	_n80_sio_reset2();
}

static void _n80_sio_command(void) {
	if (n80device.usart._ir == 1) {	// 8251 mode reg present
		n80device.usart._ir = 0;	// exchange 8251 command reg
		return;
	}
	if ((n80device.io._o21 & _bIR) != 0) {	// 8251 software reset
		_n80_sio_reset2();
		return;
	}
	n80device.usart._rxe = (n80device.io._o21 & _bRxE) ? 1 : 0;	//recieve enabled
	if ((n80device.io._o21 & _bER) != 0) {	// error reset (clear)
		n80device.usart._fake = 1;
		n80device.usart._ovr = 0;
	}
}
	
static BYTE _n80_sio_status(void) {
	BYTE d = 0x85;	// always DSR, TxE, TxRDY on
	if (n80device.usart._ovr != 0)
		d |= 0x10;
	if ((n80device.io._oE6 & 0x04) != 0) {
		if (n80device.usart._rxrdy == 0)
			return d;
	}
	if (n80device.usart._rxe != 0)
		d |= 0x02;
	return d;
}
	
static void _n80_sio_rxd(LPZ80CPU cpu, BYTE d) {
	n80device.usart._rxd = d;		// save to reciever buffer
	if (n80device.usart._rxrdy != 0)
		n80device.usart._ovr = 1;	// overrun error occured
	n80device.usart._rxrdy = 1;
	n80device.pic.int0(cpu);
}
	
static BYTE _n80_sio_read(void) {
	BYTE d = 0;
	if ((n80device.io._oE6 & 0x04) == 0) {	//PC-8001 polling read
		if (n80device.usart._fake == 1) {
			n80device.usart._fake = 0;
			d = 0xff;
		} else
			d = n80device.cmt.casdata();
	} else {								//PC-8801 interrupt read
		n80device.usart._fake = 0;
		if (n80device.usart._rxrdy == 1) {
			n80device.usart._rxrdy = 0;
			d = n80device.usart._rxd;
		} else
			d = 0xff;
	}
	return d;
}
static void _n80_sio_write(BYTE d) {
	FILE *fp = fopen(n80device.save_cmt_path, "ab");
	if (fp != NULL) {
		fputc(d, fp);
		fclose(fp);
	}
}

export void _n80_init_sio(void) {
	n80device.usart.reset = _n80_sio_reset;
	n80device.usart.cmd = _n80_sio_command;
	n80device.usart.status = _n80_sio_status;
	n80device.usart.rxd = _n80_sio_rxd;
	n80device.usart.read = _n80_sio_read;
	n80device.usart.write = _n80_sio_write;
	_n80_sio_reset();
}

#ifdef __cplusplus
	}	// extern "C"
#endif
