/**--------------------------------------------------------------------------
 **
 **		Z80 Emulator Ver 3.00
 **		Copyright (C)1993-2010 H.Kanemoto
 **
 **		This is a free software. You may copy or distribute
 **		it without any permissions. But there are NO WARRANTY
 **		of use. Entire risk of use is with you.
 **
 **------------------------------------------------------------------------*/
#include "z80.h"
#include "z80mac.h"
#ifdef __cplusplus
extern "C"
{
#endif
#define export
/**--------------------------------------------------------------------------]]
 **		Decoder
 **------------------------------------------------------------------------*/
export void _dz80_decoder_ed(Z80CPU *cpu) {
	switch (cpu->dbgctx.fetchb(cpu)) {
	case 0x40: __dz80_op_plane(cpu, "IN B,(C)");	break;
	case 0x41: __dz80_op_plane(cpu, "OUT (C),B");	break;
	case 0x42: __dz80_op_plane(cpu, "SBC HL,BC");	break;
	case 0x43: __dz80_op_mem16w(cpu, "LD (nn),BC");	break;
	case 0x44: __dz80_op_plane(cpu, "NEG");			break;
	case 0x45: __dz80_op_plane(cpu, "RETN");		break;
	case 0x46: __dz80_op_plane(cpu, "IM 0");		break;
	case 0x47: __dz80_op_plane(cpu, "LD I,A");		break;

	case 0x48: __dz80_op_plane(cpu, "IN C,(C)");	break;
	case 0x49: __dz80_op_plane(cpu, "OUT (C),C");	break;
	case 0x4A: __dz80_op_plane(cpu, "ADC HL,BC");	break;
	case 0x4B: __dz80_op_mem16r(cpu, "LD BC,(nn)");	break;
	case 0x4C: __dz80_op_plane(cpu, "NEG");			break;	// shadow
	case 0x4D: __dz80_op_plane(cpu, "RETI");		break;
	case 0x4E: __dz80_op_plane(cpu, "IM 0");		break;	// shadow
	case 0x4F: __dz80_op_plane(cpu, "LD R,A");		break;

	case 0x50: __dz80_op_plane(cpu, "IN D,(C)");	break;
	case 0x51: __dz80_op_plane(cpu, "OUT (C),D");	break;
	case 0x52: __dz80_op_plane(cpu, "SBC HL,DE");	break;
	case 0x53: __dz80_op_mem16w(cpu, "LD (nn),DE");	break;
	case 0x54: __dz80_op_plane(cpu, "NEG");			break;	// shadow
	case 0x55: __dz80_op_plane(cpu, "RETN");		break;	// shadow
	case 0x56: __dz80_op_plane(cpu, "IM 1");		break;	// shadow
	case 0x57: __dz80_op_plane(cpu, "LD A,I");		break;

	case 0x58: __dz80_op_plane(cpu, "IN E,(C)");	break;
	case 0x59: __dz80_op_plane(cpu, "OUT (C),B");	break;
	case 0x5A: __dz80_op_plane(cpu, "ADC HL,DE");	break;
	case 0x5B: __dz80_op_mem16r(cpu, "LD DE,(nn)");	break;
	case 0x5C: __dz80_op_plane(cpu, "NEG");			break;	// shadow
	case 0x5D: __dz80_op_plane(cpu, "RETN");		break;	// shadow
	case 0x5E: __dz80_op_plane(cpu, "IM 2");		break;
	case 0x5F: __dz80_op_plane(cpu, "LD A,R");		break;

	case 0x60: __dz80_op_plane(cpu, "IN H,(C)");	break;
	case 0x61: __dz80_op_plane(cpu, "OUT (C),B");	break;
	case 0x62: __dz80_op_plane(cpu, "SBC HL,HL");	break;
	case 0x63: __dz80_op_mem16w(cpu, "LD (nn),HL");	break;
	case 0x64: __dz80_op_plane(cpu, "NEG");			break;	// shadow
	case 0x65: __dz80_op_plane(cpu, "RETN");		break;	// shadow
	case 0x66: __dz80_op_plane(cpu, "IM 0");		break;	// shadow
	case 0x67: __dz80_op_plane(cpu, "RRD");			break;

	case 0x68: __dz80_op_plane(cpu, "IN L,(C)");	break;
	case 0x69: __dz80_op_plane(cpu, "OUT (C),L");	break;
	case 0x6A: __dz80_op_plane(cpu, "ADC HL,HL");	break;
	case 0x6B: __dz80_op_mem16r(cpu, "LD HL,(nn)");	break;
	case 0x6C: __dz80_op_plane(cpu, "NEG");			break;	// shadow
	case 0x6D: __dz80_op_plane(cpu, "RETN");		break;	// shadow
	case 0x6E: __dz80_op_plane(cpu, "IM 0");		break;	// shadow
	case 0x6F: __dz80_op_plane(cpu, "RLD");			break;

	case 0x70: __dz80_op_plane(cpu, "IN (C)");		break;
	case 0x71: __dz80_op_plane(cpu, "OUT (C),0");	break;
	case 0x72: __dz80_op_plane(cpu, "SBC HL,SP");	break;
	case 0x73: __dz80_op_mem16w(cpu, "LD (nn),SP");	break;
	case 0x74: __dz80_op_plane(cpu, "NEG");			break;	// shadow
	case 0x75: __dz80_op_plane(cpu, "RETN");		break;	// shadow
	case 0x76: __dz80_op_plane(cpu, "IM 1");		break;	// shadow

	case 0x78: __dz80_op_plane(cpu, "IN A,(C)");	break;
	case 0x79: __dz80_op_plane(cpu, "OUT (C),A");	break;
	case 0x7A: __dz80_op_plane(cpu, "ADC HL,SP");	break;
	case 0x7B: __dz80_op_mem16r(cpu, "LD SP,(nn)");	break;
	case 0x7C: __dz80_op_plane(cpu, "NEG");			break;	// shadow
	case 0x7D: __dz80_op_plane(cpu, "RETN");		break;	// shadow
	case 0x7E: __dz80_op_plane(cpu, "IM 2");		break;	// shadow

	case 0xA0: __dz80_op_plane(cpu, "LDI");			break;
	case 0xA1: __dz80_op_plane(cpu, "CPI");			break;
	case 0xA2: __dz80_op_plane(cpu, "INI");			break;
	case 0xA3: __dz80_op_plane(cpu, "OUTI");		break;
	case 0xA8: __dz80_op_plane(cpu, "LDD");			break;
	case 0xA9: __dz80_op_plane(cpu, "CPD");			break;
	case 0xAA: __dz80_op_plane(cpu, "IND");			break;
	case 0xAB: __dz80_op_plane(cpu, "OUTD");		break;

	case 0xB0: __dz80_op_plane(cpu, "LDIR");		break;
	case 0xB1: __dz80_op_plane(cpu, "CPIR");		break;
	case 0xB2: __dz80_op_plane(cpu, "INIR");		break;
	case 0xB3: __dz80_op_plane(cpu, "OUTIR");		break;

	case 0xB8: __dz80_op_plane(cpu, "LDDR");		break;
	case 0xB9: __dz80_op_plane(cpu, "CPDR");		break;
	case 0xBA: __dz80_op_plane(cpu, "INDR");		break;
	case 0xBB: __dz80_op_plane(cpu, "OUTDR");		break;
	default:	break;
	}
}

#ifdef __cplusplus
}	// extern "C"
#endif
