/**--------------------------------------------------------------------------
 **
 **		Z80 Emulator Ver 3.00
 **		Copyright (C)1993-2010 H.Kanemoto
 **
 **		This is a free software. You may copy or distribute
 **		it without any permissions. But there are NO WARRANTY
 **		of use. Entire risk of use is with you.
 **
 **------------------------------------------------------------------------*/
#include "z80.h"
#include "z80mac.h"
#ifdef __cplusplus
extern "C"
{
#endif
#define export
/**--------------------------------------------------------------------------
 **		Decoder
 **------------------------------------------------------------------------*/
export void _z80_decoder_xd_cb(Z80CPU *cpu, int IXY) {
	LPZ80REGS	r = &cpu->r;
	USHORT		idx = __z80_index(r->xr[IXY], __z80_fetchb(cpu));
	BYTE		b = __z80_mbread(cpu, idx);

	switch (__z80_fetchb_Mn(cpu)) {
	case 0x00: /* RLC (IX+d),B*/__z80_microcode_rlc(&b, &r->h.F); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x01: /* RLC (IX+d),C*/__z80_microcode_rlc(&b, &r->h.F); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x02: /* RLC (IX+d),D*/__z80_microcode_rlc(&b, &r->h.F); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x03: /* RLC (IX+d),E*/__z80_microcode_rlc(&b, &r->h.F); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x04: /* RLC (IX+d),H*/__z80_microcode_rlc(&b, &r->h.F); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x05: /* RLC (IX+d),L*/__z80_microcode_rlc(&b, &r->h.F); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x06: /* RLC (IX+d)  */__z80_microcode_rlc(&b, &r->h.F); __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x07: /* RLC (IX+d),A*/__z80_microcode_rlc(&b, &r->h.F); r->h.A = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;

	case 0x08: /* RRC (IX+d),B*/__z80_microcode_rrc(&b, &r->h.F); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x09: /* RRC (IX+d),C*/__z80_microcode_rrc(&b, &r->h.F); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x0A: /* RRC (IX+d),D*/__z80_microcode_rrc(&b, &r->h.F); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x0B: /* RRC (IX+d),E*/__z80_microcode_rrc(&b, &r->h.F); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x0C: /* RRC (IX+d),H*/__z80_microcode_rrc(&b, &r->h.F); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x0D: /* RRC (IX+d),L*/__z80_microcode_rrc(&b, &r->h.F); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x0E: /* RRC (IX+d)  */__z80_microcode_rrc(&b, &r->h.F); __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x0F: /* RRC (IX+d),A*/__z80_microcode_rrc(&b, &r->h.F); r->h.A = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;

	case 0x10: /* RL (IX+d),B*/	__z80_microcode_rl(&b, &r->h.F); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x11: /* RL (IX+d),C*/	__z80_microcode_rl(&b, &r->h.F); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x12: /* RL (IX+d),D*/	__z80_microcode_rl(&b, &r->h.F); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x13: /* RL (IX+d),E*/	__z80_microcode_rl(&b, &r->h.F); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x14: /* RL (IX+d),H*/	__z80_microcode_rl(&b, &r->h.F); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x15: /* RL (IX+d),L*/	__z80_microcode_rl(&b, &r->h.F); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x16: /* RL (IX+d)  */	__z80_microcode_rl(&b, &r->h.F); __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x17: /* RL (IX+d),A*/	__z80_microcode_rl(&b, &r->h.F); r->h.A = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;

	case 0x18: /* RR (IX+d),B*/	__z80_microcode_rr(&b, &r->h.F); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x19: /* RR (IX+d),C*/	__z80_microcode_rr(&b, &r->h.F); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x1A: /* RR (IX+d),D*/	__z80_microcode_rr(&b, &r->h.F); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x1B: /* RR (IX+d),E*/	__z80_microcode_rr(&b, &r->h.F); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x1C: /* RR (IX+d),H*/	__z80_microcode_rr(&b, &r->h.F); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x1D: /* RR (IX+d),L*/	__z80_microcode_rr(&b, &r->h.F); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x1E: /* RR (IX+d)  */	__z80_microcode_rr(&b, &r->h.F); __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x1F: /* RR (IX+d),A*/	__z80_microcode_rr(&b, &r->h.F); r->h.A = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;

	case 0x20: /* SLA (IX+d),B*/__z80_microcode_sla(&b, &r->h.F); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x21: /* SLA (IX+d),C*/__z80_microcode_sla(&b, &r->h.F); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x22: /* SLA (IX+d),D*/__z80_microcode_sla(&b, &r->h.F); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x23: /* SLA (IX+d),E*/__z80_microcode_sla(&b, &r->h.F); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x24: /* SLA (IX+d),H*/__z80_microcode_sla(&b, &r->h.F); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x25: /* SLA (IX+d),L*/__z80_microcode_sla(&b, &r->h.F); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x26: /* SLA (IX+d)  */__z80_microcode_sla(&b, &r->h.F); __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x27: /* SLA (IX+d),A*/__z80_microcode_sla(&b, &r->h.F); r->h.A = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;

	case 0x28: /* SRA (IX+d),B*/__z80_microcode_sra(&b, &r->h.F); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x29: /* SRA (IX+d),C*/__z80_microcode_sra(&b, &r->h.F); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x2A: /* SRA (IX+d),D*/__z80_microcode_sra(&b, &r->h.F); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x2B: /* SRA (IX+d),E*/__z80_microcode_sra(&b, &r->h.F); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x2C: /* SRA (IX+d),H*/__z80_microcode_sra(&b, &r->h.F); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x2D: /* SRA (IX+d),L*/__z80_microcode_sra(&b, &r->h.F); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x2E: /* SRA (IX+d)  */__z80_microcode_sra(&b, &r->h.F); __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x2F: /* SRA (IX+d),A*/__z80_microcode_sra(&b, &r->h.F); r->h.A = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;

	case 0x30: /* SLL (IX+d),B*/__z80_microcode_sll(&b, &r->h.F); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x31: /* SLL (IX+d),C*/__z80_microcode_sll(&b, &r->h.F); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x32: /* SLL (IX+d),D*/__z80_microcode_sll(&b, &r->h.F); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x33: /* SLL (IX+d),E*/__z80_microcode_sll(&b, &r->h.F); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x34: /* SLL (IX+d),H*/__z80_microcode_sll(&b, &r->h.F); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x35: /* SLL (IX+d),L*/__z80_microcode_sll(&b, &r->h.F); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x36: /* SLL (IX+d)  */__z80_microcode_sll(&b, &r->h.F); __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x37: /* SLL (IX+d),A*/__z80_microcode_sll(&b, &r->h.F); r->h.A = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;

	case 0x38: /* SRL (IX+d),B*/__z80_microcode_srl(&b, &r->h.F); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x39: /* SRL (IX+d),C*/__z80_microcode_srl(&b, &r->h.F); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x3A: /* SRL (IX+d),D*/__z80_microcode_srl(&b, &r->h.F); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x3B: /* SRL (IX+d),E*/__z80_microcode_srl(&b, &r->h.F); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x3C: /* SRL (IX+d),H*/__z80_microcode_srl(&b, &r->h.F); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x3D: /* SRL (IX+d),L*/__z80_microcode_srl(&b, &r->h.F); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x3E: /* SRL (IX+d)  */__z80_microcode_srl(&b, &r->h.F); __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x3F: /* SRL (IX+d),A*/__z80_microcode_srl(&b, &r->h.F); r->h.A = b; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;

	case 0x40: /* BIT 0,(IX+d),B*/__z80_microcode_bitx(b, 0x01, &r->h.F, idx); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x41: /* BIT 0,(IX+d),C*/__z80_microcode_bitx(b, 0x01, &r->h.F, idx); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x42: /* BIT 0,(IX+d),D*/__z80_microcode_bitx(b, 0x01, &r->h.F, idx); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x43: /* BIT 0,(IX+d),E*/__z80_microcode_bitx(b, 0x01, &r->h.F, idx); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x44: /* BIT 0,(IX+d),H*/__z80_microcode_bitx(b, 0x01, &r->h.F, idx); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x45: /* BIT 0,(IX+d),L*/__z80_microcode_bitx(b, 0x01, &r->h.F, idx); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x46: /* BIT 0,(IX+d)*/__z80_microcode_bitx(b, 0x01, &r->h.F, idx); __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x47: /* BIT 0,(IX+d),A*/__z80_microcode_bitx(b, 0x01, &r->h.F, idx); r->h.A = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;

	case 0x48: /* BIT 1,(IX+d),B*/__z80_microcode_bitx(b, 0x02, &r->h.F, idx); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x49: /* BIT 1,(IX+d),C*/__z80_microcode_bitx(b, 0x02, &r->h.F, idx); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x4A: /* BIT 1,(IX+d),D*/__z80_microcode_bitx(b, 0x02, &r->h.F, idx); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x4B: /* BIT 1,(IX+d),E*/__z80_microcode_bitx(b, 0x02, &r->h.F, idx); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x4C: /* BIT 1,(IX+d),H*/__z80_microcode_bitx(b, 0x02, &r->h.F, idx); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x4D: /* BIT 1,(IX+d),L*/__z80_microcode_bitx(b, 0x02, &r->h.F, idx); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x4E: /* BIT 1,(IX+d)*/__z80_microcode_bitx(b, 0x02, &r->h.F, idx); __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x4F: /* BIT 1,(IX+d),L*/__z80_microcode_bitx(b, 0x02, &r->h.F, idx); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;

	case 0x50: /* BIT 2,(IX+d),B*/__z80_microcode_bitx(b, 0x04, &r->h.F, idx); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x51: /* BIT 2,(IX+d),C*/__z80_microcode_bitx(b, 0x04, &r->h.F, idx); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x52: /* BIT 2,(IX+d),D*/__z80_microcode_bitx(b, 0x04, &r->h.F, idx); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x53: /* BIT 2,(IX+d),E*/__z80_microcode_bitx(b, 0x04, &r->h.F, idx); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x54: /* BIT 2,(IX+d),H*/__z80_microcode_bitx(b, 0x04, &r->h.F, idx); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x55: /* BIT 2,(IX+d),L*/__z80_microcode_bitx(b, 0x04, &r->h.F, idx); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x56: /* BIT 2,(IX+d)*/__z80_microcode_bitx(b, 0x04, &r->h.F, idx); __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x57: /* BIT 2,(IX+d),A*/__z80_microcode_bitx(b, 0x04, &r->h.F, idx); r->h.A = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;

	case 0x58: /* BIT 3,(IX+d),B*/__z80_microcode_bitx(b, 0x08, &r->h.F, idx); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x59: /* BIT 3,(IX+d),C*/__z80_microcode_bitx(b, 0x08, &r->h.F, idx); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x5A: /* BIT 3,(IX+d),D*/__z80_microcode_bitx(b, 0x08, &r->h.F, idx); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x5B: /* BIT 3,(IX+d),E*/__z80_microcode_bitx(b, 0x08, &r->h.F, idx); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x5C: /* BIT 3,(IX+d),H*/__z80_microcode_bitx(b, 0x08, &r->h.F, idx); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x5D: /* BIT 3,(IX+d),L*/__z80_microcode_bitx(b, 0x08, &r->h.F, idx); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x5E: /* BIT 3,(IX+d)*/__z80_microcode_bitx(b, 0x08, &r->h.F, idx); __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x5F: /* BIT 3,(IX+d),A*/__z80_microcode_bitx(b, 0x08, &r->h.F, idx); r->h.A = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;

	case 0x60: /* BIT 4,(IX+d),B*/__z80_microcode_bitx(b, 0x10, &r->h.F, idx); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x61: /* BIT 4,(IX+d),C*/__z80_microcode_bitx(b, 0x10, &r->h.F, idx); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x62: /* BIT 4,(IX+d),D*/__z80_microcode_bitx(b, 0x10, &r->h.F, idx); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x63: /* BIT 4,(IX+d),E*/__z80_microcode_bitx(b, 0x10, &r->h.F, idx); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x64: /* BIT 4,(IX+d),H*/__z80_microcode_bitx(b, 0x10, &r->h.F, idx); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x65: /* BIT 4,(IX+d),L*/__z80_microcode_bitx(b, 0x10, &r->h.F, idx); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x66: /* BIT 4,(IX+d)*/__z80_microcode_bitx(b, 0x10, &r->h.F, idx); __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x67: /* BIT 4,(IX+d),A*/__z80_microcode_bitx(b, 0x10, &r->h.F, idx); r->h.A = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;

	case 0x68: /* BIT 5,(IX+d),B*/__z80_microcode_bitx(b, 0x20, &r->h.F, idx); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x69: /* BIT 5,(IX+d),C*/__z80_microcode_bitx(b, 0x20, &r->h.F, idx); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x6A: /* BIT 5,(IX+d),D*/__z80_microcode_bitx(b, 0x20, &r->h.F, idx); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x6B: /* BIT 5,(IX+d),E*/__z80_microcode_bitx(b, 0x20, &r->h.F, idx); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x6C: /* BIT 5,(IX+d),H*/__z80_microcode_bitx(b, 0x20, &r->h.F, idx); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x6D: /* BIT 5,(IX+d),L*/__z80_microcode_bitx(b, 0x20, &r->h.F, idx); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x6E: /* BIT 5,(IX+d)*/__z80_microcode_bitx(b, 0x20, &r->h.F, idx); __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x6F: /* BIT 5,(IX+d),A*/__z80_microcode_bitx(b, 0x20, &r->h.F, idx); r->h.A = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;

	case 0x70: /* BIT 6,(IX+d),B*/__z80_microcode_bitx(b, 0x40, &r->h.F, idx); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x71: /* BIT 6,(IX+d),C*/__z80_microcode_bitx(b, 0x40, &r->h.F, idx); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x72: /* BIT 6,(IX+d),D*/__z80_microcode_bitx(b, 0x40, &r->h.F, idx); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x73: /* BIT 6,(IX+d),E*/__z80_microcode_bitx(b, 0x40, &r->h.F, idx); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x74: /* BIT 6,(IX+d),H*/__z80_microcode_bitx(b, 0x40, &r->h.F, idx); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x75: /* BIT 6,(IX+d),L*/__z80_microcode_bitx(b, 0x40, &r->h.F, idx); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x76: /* BIT 6,(IX+d)*/__z80_microcode_bitx(b, 0x40, &r->h.F, idx); __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x77: /* BIT 6,(IX+d),A*/__z80_microcode_bitx(b, 0x40, &r->h.F, idx); r->h.A = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;

	case 0x78: /* BIT 7,(IX+d),B*/__z80_microcode_bitx(b, 0x80, &r->h.F, idx); r->h.B = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x79: /* BIT 7,(IX+d),C*/__z80_microcode_bitx(b, 0x80, &r->h.F, idx); r->h.C = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x7A: /* BIT 7,(IX+d),D*/__z80_microcode_bitx(b, 0x80, &r->h.F, idx); r->h.D = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x7B: /* BIT 7,(IX+d),E*/__z80_microcode_bitx(b, 0x80, &r->h.F, idx); r->h.E = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x7C: /* BIT 7,(IX+d),H*/__z80_microcode_bitx(b, 0x80, &r->h.F, idx); r->h.H = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x7D: /* BIT 7,(IX+d),L*/__z80_microcode_bitx(b, 0x80, &r->h.F, idx); r->h.L = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x7E: /* BIT 7,(IX+d)*/__z80_microcode_bitx(b, 0x80, &r->h.F, idx); __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;
	case 0x7F: /* BIT 7,(IX+d),A*/__z80_microcode_bitx(b, 0x80, &r->h.F, idx); r->h.A = b; __z80_mbwrite(cpu, idx, b); r->x.T = 20; break;

	case 0x80: /* RES 0,(IX+d),B*/b &= 0xfe; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0x81: /* RES 0,(IX+d),C*/b &= 0xfe; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0x82: /* RES 0,(IX+d),D*/b &= 0xfe; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0x83: /* RES 0,(IX+d),E*/b &= 0xfe; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0x84: /* RES 0,(IX+d),H*/b &= 0xfe; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0x85: /* RES 0,(IX+d),L*/b &= 0xfe; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0x86: /* RES 0,(IX+d)*/b &= 0xfe; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x87: /* RES 0,(IX+d),A*/b &= 0xfe; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;

	case 0x88: /* RES 1,(IX+d),B*/b &= 0xfd; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0x89: /* RES 1,(IX+d),C*/b &= 0xfd; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0x8A: /* RES 1,(IX+d),D*/b &= 0xfd; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0x8B: /* RES 1,(IX+d),E*/b &= 0xfd; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0x8C: /* RES 1,(IX+d),H*/b &= 0xfd; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0x8D: /* RES 1,(IX+d),L*/b &= 0xfd; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0x8E: /* RES 1,(IX+d)*/b &= 0xfd; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x8F: /* RES 1,(IX+d),A*/b &= 0xfd; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;

	case 0x90: /* RES 2,(IX+d),B*/b &= 0xfb; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0x91: /* RES 2,(IX+d),C*/b &= 0xfb; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0x92: /* RES 2,(IX+d),D*/b &= 0xfb; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0x93: /* RES 2,(IX+d),E*/b &= 0xfb; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0x94: /* RES 2,(IX+d),H*/b &= 0xfb; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0x95: /* RES 2,(IX+d),L*/b &= 0xfb; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0x96: /* RES 2,(IX+d)*/b &= 0xfb; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x97: /* RES 2,(IX+d),A*/b &= 0xfb; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;

	case 0x98: /* RES 3,(IX+d),B*/b &= 0xf7; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0x99: /* RES 3,(IX+d),C*/b &= 0xf7; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0x9A: /* RES 3,(IX+d),D*/b &= 0xf7; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0x9B: /* RES 3,(IX+d),E*/b &= 0xf7; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0x9C: /* RES 3,(IX+d),H*/b &= 0xf7; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0x9D: /* RES 3,(IX+d),L*/b &= 0xf7; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0x9E: /* RES 3,(IX+d)*/b &= 0xf7; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0x9F: /* RES 3,(IX+d),A*/b &= 0xf7; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;

	case 0xA0: /* RES 4,(IX+d),B*/b &= 0xef; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0xA1: /* RES 4,(IX+d),C*/b &= 0xef; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0xA2: /* RES 4,(IX+d),D*/b &= 0xef; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0xA3: /* RES 4,(IX+d),E*/b &= 0xef; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0xA4: /* RES 4,(IX+d),H*/b &= 0xef; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0xA5: /* RES 4,(IX+d),L*/b &= 0xef; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0xA6: /* RES 4,(IX+d)*/b &= 0xef; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0xA7: /* RES 4,(IX+d),A*/b &= 0xef; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;

	case 0xA8: /* RES 5,(IX+d),B*/b &= 0xdf; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0xA9: /* RES 5,(IX+d),C*/b &= 0xdf; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0xAA: /* RES 5,(IX+d),D*/b &= 0xdf; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0xAB: /* RES 5,(IX+d),E*/b &= 0xdf; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0xAC: /* RES 5,(IX+d),H*/b &= 0xdf; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0xAD: /* RES 5,(IX+d),L*/b &= 0xdf; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0xAE: /* RES 5,(IX+d)*/b &= 0xdf; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0xAF: /* RES 5,(IX+d),A*/b &= 0xdf; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;

	case 0xB0: /* RES 6,(IX+d),B*/b &= 0xbf; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0xB1: /* RES 6,(IX+d),C*/b &= 0xbf; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0xB2: /* RES 6,(IX+d),D*/b &= 0xbf; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0xB3: /* RES 6,(IX+d),E*/b &= 0xbf; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0xB4: /* RES 6,(IX+d),H*/b &= 0xbf; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0xB5: /* RES 6,(IX+d),L*/b &= 0xbf; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0xB6: /* RES 6,(IX+d)*/b &= 0xbf; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0xB7: /* RES 6,(IX+d),A*/b &= 0xbf; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;

	case 0xB8: /* RES 7,(IX+d),B*/b &= 0x7f; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0xB9: /* RES 7,(IX+d),C*/b &= 0x7f; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0xBA: /* RES 7,(IX+d),D*/b &= 0x7f; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0xBB: /* RES 7,(IX+d),E*/b &= 0x7f; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0xBC: /* RES 7,(IX+d),H*/b &= 0x7f; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0xBD: /* RES 7,(IX+d),L*/b &= 0x7f; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0xBE: /* RES 7,(IX+d)*/b &= 0x7f; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0xBF: /* RES 7,(IX+d),A*/b &= 0x7f; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;

	case 0xC0: /* SET 0,(IX+d),B*/b |= 0x01; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0xC1: /* SET 0,(IX+d),C*/b |= 0x01; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0xC2: /* SET 0,(IX+d),D*/b |= 0x01; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0xC3: /* SET 0,(IX+d),E*/b |= 0x01; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0xC4: /* SET 0,(IX+d),H*/b |= 0x01; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0xC5: /* SET 0,(IX+d),L*/b |= 0x01; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0xC6: /* SET 0,(IX+d)*/b |= 0x01; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0xC7: /* SET 0,(IX+d),A*/b |= 0x01; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;

	case 0xC8: /* SET 1,(IX+d),B*/b |= 0x02; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0xC9: /* SET 1,(IX+d),C*/b |= 0x02; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0xCA: /* SET 1,(IX+d),D*/b |= 0x02; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0xCB: /* SET 1,(IX+d),E*/b |= 0x02; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0xCC: /* SET 1,(IX+d),H*/b |= 0x02; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0xCD: /* SET 1,(IX+d),L*/b |= 0x02; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0xCE: /* SET 1,(IX+d)*/b |= 0x02; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0xCF: /* SET 1,(IX+d),A*/b |= 0x02; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;

	case 0xD0: /* SET 2,(IX+d),B*/b |= 0x04; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0xD1: /* SET 2,(IX+d),C*/b |= 0x04; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0xD2: /* SET 2,(IX+d),D*/b |= 0x04; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0xD3: /* SET 2,(IX+d),E*/b |= 0x04; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0xD4: /* SET 2,(IX+d),H*/b |= 0x04; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0xD5: /* SET 2,(IX+d),L*/b |= 0x04; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0xD6: /* SET 2,(IX+d)*/b |= 0x04; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0xD7: /* SET 2,(IX+d),A*/b |= 0x04; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;

	case 0xD8: /* SET 3,(IX+d),B*/b |= 0x08; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0xD9: /* SET 3,(IX+d),C*/b |= 0x08; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0xDA: /* SET 3,(IX+d),D*/b |= 0x08; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0xDB: /* SET 3,(IX+d),E*/b |= 0x08; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0xDC: /* SET 3,(IX+d),H*/b |= 0x08; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0xDD: /* SET 3,(IX+d),L*/b |= 0x08; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0xDE: /* SET 3,(IX+d)*/b |= 0x08; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0xDF: /* SET 3,(IX+d),A*/b |= 0x08; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;

	case 0xE0: /* SET 4,(IX+d),B*/b |= 0x10; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0xE1: /* SET 4,(IX+d),C*/b |= 0x10; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0xE2: /* SET 4,(IX+d),D*/b |= 0x10; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0xE3: /* SET 4,(IX+d),E*/b |= 0x10; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0xE4: /* SET 4,(IX+d),H*/b |= 0x10; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0xE5: /* SET 4,(IX+d),L*/b |= 0x10; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0xE6: /* SET 4,(IX+d)*/b |= 0x10; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0xE7: /* SET 4,(IX+d),A*/b |= 0x10; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;

	case 0xE8: /* SET 5,(IX+d),B*/b |= 0x20; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0xE9: /* SET 5,(IX+d),C*/b |= 0x20; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0xEA: /* SET 5,(IX+d),D*/b |= 0x20; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0xEB: /* SET 5,(IX+d),E*/b |= 0x20; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0xEC: /* SET 5,(IX+d),H*/b |= 0x20; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0xED: /* SET 5,(IX+d),L*/b |= 0x20; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0xEE: /* SET 5,(IX+d)*/b |= 0x20; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0xEF: /* SET 5,(IX+d),A*/b |= 0x20; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;

	case 0xF0: /* SET 6,(IX+d),B*/b |= 0x40; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0xF1: /* SET 6,(IX+d),C*/b |= 0x40; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0xF2: /* SET 6,(IX+d),D*/b |= 0x40; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0xF3: /* SET 6,(IX+d),E*/b |= 0x40; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0xF4: /* SET 6,(IX+d),H*/b |= 0x40; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0xF5: /* SET 6,(IX+d),L*/b |= 0x40; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0xF6: /* SET 6,(IX+d)*/b |= 0x40; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0xF7: /* SET 6,(IX+d),A*/b |= 0x40; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;

	case 0xF8: /* SET 7,(IX+d),B*/b |= 0x80; __z80_mbwrite(cpu, idx, b); r->h.B = b; r->x.T = 23; break;
	case 0xF9: /* SET 7,(IX+d),C*/b |= 0x80; __z80_mbwrite(cpu, idx, b); r->h.C = b; r->x.T = 23; break;
	case 0xFA: /* SET 7,(IX+d),D*/b |= 0x80; __z80_mbwrite(cpu, idx, b); r->h.D = b; r->x.T = 23; break;
	case 0xFB: /* SET 7,(IX+d),E*/b |= 0x80; __z80_mbwrite(cpu, idx, b); r->h.E = b; r->x.T = 23; break;
	case 0xFC: /* SET 7,(IX+d),H*/b |= 0x80; __z80_mbwrite(cpu, idx, b); r->h.H = b; r->x.T = 23; break;
	case 0xFD: /* SET 7,(IX+d),L*/b |= 0x80; __z80_mbwrite(cpu, idx, b); r->h.L = b; r->x.T = 23; break;
	case 0xFE: /* SET 7,(IX+d)*/b |= 0x80; __z80_mbwrite(cpu, idx, b); r->x.T = 23; break;
	case 0xFF: /* SET 7,(IX+d),A*/b |= 0x80; __z80_mbwrite(cpu, idx, b); r->h.A = b; r->x.T = 23; break;
	}
}

#ifdef __cplusplus
}	// extern "C"
#endif
